.686
.model flat,stdcall 
option casemap:none
.mmx
.xmm

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data
align 16
  actarr db   1,  3,  2,  3,  16,  6,  9, 48,  14,  8, 42, 27,  19, 15,  7, 40
         db  34, 30, 28, 22,  18, 12,  4,  0, 101,101,101,101, 101,101,101,101
         db 101,101,101,101, 101,101,101,101, 101,101,101,101, 101,101,101,101
         db 101,101,101,101,   1,  1,  1,  1,   1,  1,  1,  1,   1,  1,  1,  1

  maxarr db   5,  7, 11, 13,  17, 19, 23, 53,  29, 31, 59, 37,  41, 43, 47, 61
         db  67, 71, 73, 79,  83, 89, 97,101, 103,107,109,113, 127,131,137,139
         db 149,151,157,163, 167,173,179,181, 191,193,197,199, 211,223,227,229
         db 233,239,241,251,   6,  6,  6,  6,   6,  6,  6,  6,   6,  6,  6,  6

  plus24 db 16 dup(2)
  ones16 db 16 dup(1)
  xswap6 db 16 dup(6)

  zeroes dd 0         ;  k  ebx     plus24 db 2,2,2,2
         dd 0
  anycnt dd 0
  allcnt dd 0         ;  totals dd 0

  times  dd 10000000
  szCap  db "SMA",0   ;  SSE2,MMX,ALU version
  P      dd 0
  PID    dd 0

  CrTm   dd 0, 0
  ExTm   dd 0, 0
  KnTm   dd 0, 0
  UsTm   dd 0, 0

  szFmt  db "%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",0
  szMsg  db 256 dup (0)


.code
start:
   movdqa   XMM0, actarr    ; 0  actarr  a
   movdqa   XMM2, actarr+16 ; 2  actarr  a+16
   movq      MM0, qword ptr actarr+32
   movq      MM2, qword ptr actarr+40
   mov       eax, dword ptr actarr+48

   movdqa   XMM3, maxarr    ; 3  maxarr  m
   movdqa   XMM6, maxarr+16 ; 6  maxarr  m+16
   movq      MM3, qword ptr maxarr+32
   movq      MM6, qword ptr maxarr+40
   mov       edx, dword ptr maxarr+48
   
   movdqa   XMM1, ones16    ; 1  16 1s   1
   movdqa   XMM4, plus24    ; 4  plus24  p24
 ; movdqa   XMM6, xswap6

   movq      MM1, qword ptr ones16    ; 1  16 1s   1
   movq      MM4, qword ptr plus24    ; 4  plus24  p24
 ; movq      MM6, qword ptr xswap6

 ; mov       esi, dword ptr ones16      ; not part of ALU algorithm
   mov       ebx, dword ptr plus24
 ; mov       ecx, dword ptr xswap6

   mov       edi, 0         ; zeros 
 ; mov       esi, 0         ; temp

 ; pxor     XMM5, XMM5      ; temp
 ; pxor     XMM7, XMM7      ; temp



   mov      ecx, times      ; use ecx for times

manybites:
   paddb    XMM0, XMM4     ; a = a + p24    5, 8                ; add the 2 or 4
   paddb    XMM2, XMM4     ; a = a + p24    5, 8                ; add the 2 or 4
   paddb     MM0,  MM4     ; a = a + p24    5, 8                ; add the 2 or 4
   paddb     MM2,  MM4     ; a = a + p24    5, 8                ; add the 2 or 4
   add       eax,  ebx     ; a = a + p24
;=======================================
   movdqa   XMM7, XMM3     ; 5, 7  : 5, 7              ; psubb    XMM7, XMM1     ; 4, 6  : 1, 1
   pxor     XMM5, XMM5     ; 0, 0

   pcmpgtb  XMM7, XMM0     ;FF, FF : 5, 8    4, 6 :
   pandn    XMM7, XMM3     ; 5,  7 : 5, 7
   psubb    XMM0, XMM7     ; 0,  1 : 5, 7

   pcmpeqb  XMM5, XMM0     ;FF,  0 : 0, 1    0, 0 :    ; pand     XMM5, XMM1
   paddb    XMM5, XMM1     ; 0,  1 : 1, 1
   psadbw   XMM5, XMM1     ; 0_                PMINUB  ?? find min of bytes

   pextrw    edi, XMM5, 0
   add       edi,  0
   pextrw    esi, XMM5, 4  ;
   add       edi,  esi     ;


   movq      MM7,  MM3     ; 5, 7  : 5, 7              ; psubb    XMM7, XMM1     ; 4, 6  : 1, 1
   pxor      MM5,  MM5     ; 0, 0

   pcmpgtb   MM7,  MM0     ;FF, FF : 5, 8    4, 6 :
   pandn     MM7,  MM3     ; 5,  7 : 5, 7
   psubb     MM0,  MM7     ; 0,  1 : 5, 7

   pcmpeqb   MM5,  MM0     ;FF,  0 : 0, 1    0, 0 :    ; pand     XMM5, XMM1
   paddb     MM5,  MM1     ; 0,  1 : 1, 1
   psadbw    MM5,  MM1     ; 0_                PMINUB  ?? find min of bytes

   pextrw    esi,  MM5, 0   ; xor esi, esi
   add       edi,  esi
;===================================
;  0 -> 2  act
;  3 -> 6  max
;===================================
   movdqa   XMM7, XMM6     ; 5, 7  : 5, 7              ; psubb    XMM7, XMM1     ; 4, 6  : 1, 1
   pxor     XMM5, XMM5     ; 0, 0

   pcmpgtb  XMM7, XMM2     ;FF, FF : 5, 8    4, 6 :
   pandn    XMM7, XMM6     ; 5,  7 : 5, 7
   psubb    XMM2, XMM7     ; 0,  1 : 5, 7

   pcmpeqb  XMM5, XMM2     ;FF,  0 : 0, 1    0, 0 :    ; pand     XMM5, XMM1
   paddb    XMM5, XMM1     ; 0,  1 : 1, 1
   psadbw   XMM5, XMM1     ; 0_                PMINUB  ?? find min of bytes

   pextrw   esi, XMM5, 0
   add      edi, esi
   pextrw   esi, XMM5, 4   ;
   add      edi, esi       ;


   movq      MM7,  MM6     ; 5, 7  : 5, 7              ; psubb    XMM7, XMM1     ; 4, 6  : 1, 1
   pxor      MM5,  MM5     ; 0, 0

   pcmpgtb   MM7,  MM2     ;FF, FF : 5, 8    4, 6 :
   pandn     MM7,  MM6     ; 5,  7 : 5, 7
   psubb     MM2,  MM7     ; 0,  1 : 5, 7

   pcmpeqb   MM5,  MM2     ;FF,  0 : 0, 1    0, 0 :    ; pand     XMM5, XMM1
   paddb     MM5,  MM1     ; 0,  1 : 1, 1
   psadbw    MM5,  MM1     ; 0_                PMINUB  ?? find min of bytes

   pextrw   esi,  MM5, 0
   add      edi, esi
;===================================
   cmp  al, dl   ;  a < m    4 < 5
   jc  @F        ; al < dl   skip sub 5, == 0
   sub  al, dl   ; do sub, set zero flag if result is 0
   jnz @F        ; if not a 0  skip inc zeroes
   inc edi       ; inc zeroes
@@:
   cmp  ah, dh   ;  a < m    4 < 5
   jc  @F        ; al < dl
   sub  ah, dh
   jnz @F
   inc edi       ; inc zeroes
@@:
   ror eax, 16   ; swap the higher two bytes with the lower
   ror edx, 16   ;     - bswap - could be used instead for each - ror -

   cmp  al, dl   ;  a < m    4 < 5
   jc  @F        ; al < dl
   sub  al, dl
   jnz @F
   inc edi       ; inc zeroes
@@:
   cmp  ah, dh   ;  a < m    4 < 5
   jc  @F        ; al < dl
   sub  ah, dh
   jnz @F
   inc edi       ; inc zeroes
@@:
   ror eax, 16   ; put dword back in correct order
   ror edx, 16   ;
;===================================

   cmp edi, 1
   sbb anycnt, -1
   add allcnt, edi

;------------------------------------------------------
;  Optimization: do ebx   copy to MM4, XMM4   low dword
;                shuffle to other dwords 
;------------------------------------------------------
   pxor     XMM4, xswap6             ; movdqa   XMM7, xswap6    ; pxor     XMM4, XMM7
   pxor      MM4, qword ptr xswap6
 ; xor       ebx, dword ptr xswap6   ; movdqa   plus24, XMM4   ; save it/update the copy in memory
   xor       ebx, 06060606h

   dec ecx                 ; dec times
   jnz manybites


   movdqa   actarr+ 0, xmm0   ; save it/update the copy in memory
   movdqa   actarr+16, xmm2   ; save it/update the copy in memory
   movdqa   actarr+32,  mm0
   movdqa   actarr+40,  mm2
   mov dword ptr actarr+48, eax         ; save it/update the copy in memory

   movdqa   plus24, xmm4   



   invoke GetCurrentProcess
   mov P, eax
   invoke GetProcessTimes, P, addr CrTm, addr ExTm, addr KnTm, addr UsTm

   xor eax, eax
   xor edx, edx
   mov ecx, 52
@@:
   dec ecx
   movzx edx, [actarr+ecx]
   add eax, edx
   cmp ecx, 0
   jnz @B

   mov times, eax

   invoke wsprintf, addr szMsg, addr szFmt, anycnt, allcnt, KnTm+0, UsTm+0, times
   invoke MessageBox, NULL, addr szMsg, addr szCap, MB_OK

 ;   mov actarr+4, 0
 ;   add dword ptr actarr, 30303030h
 ;   invoke MessageBox, NULL, addr actarr, addr szCap, MB_OK

   invoke ExitProcess, NULL
end start